var jobs = require('./jobs');

module.exports = function(obj) {
  return new Promise(function(resolve,reject){
    var todo = 0;
    var done = function(){
      todo--; if(todo <= 0) resolve(obj);
    }

    var runJob = function(obj, type) {
      todo++;
      jobs.run('nunjucks', obj, type)
      .then(function(data) {
        if(!obj.rendered) obj.rendered = [];
        data.forEach(function(o){
          obj.rendered.push(o);
        });

        done();
      })
      .catch(function(e) {reject(e)})
    }

    obj.pages.forEach(function(page) {
      runJob(page,'article')
    })
    obj.tags.forEach(function(tag) {
      runJob(tag,'tag')
    })
    obj.redirects.forEach(function(redirect) {
      runJob(redirect,'redirect')
    })
    if(todo <= 0) resolve(obj);
  })
}
